
#include <iostream>
#include <vector> 
#include <map>
using namespace std;

#include "ara/log/logging.h"
#include "ara/exec/execution_client.h"
#include "fusion/executable.h"
#include "pub/PubDataWrapper.h"
#include "pub/PubWrapperHelper.h"
#include "Fusion_PubDataWrapper.h"
#include "Fusion_GeneralWrapper.h"
#include "int_test.h"
#include "CCameraObjectsConcatenator.h"
#include "CVedToEgoMotion.h"
#include "ccameraobjectswrappertofusioncameradata.h"
#include "cfusionobjectowrapperobject.h"
#include "clidarobjectswrappertofusion.h"
#include <chrono>
#include <string>
#include <fstream>
#include <unistd.h>
extern "C" {
    #include <stdio.h>
    #include <stdlib.h>
    #include "Fusion_main.h"
    #include "Fusion_SLAM_types.h"
    #include "SimUtils.h"
    #include "TueObjFusn_TrackableListProps.h"
    #include "TueObjFusn_ObjectListProps.h"
    #include "TueObjFusn_MatchIndex.h"
    #include "tue_prv_common_matrix.h"
    #include "fusion_ext.h"
}



#ifndef EGO_VEHICLE_FAKE_DATA_LEN
#define EGO_VEHICLE_FAKE_DATA_LEN   9999u
#define SENSORS_FAKE_DATA_LEN       2853u
#endif

#define LIDAR_SENSOR_COLS   1512u
#define EGO_VEHICLE_COLS     55u
#define CAMERA_SENSOR_COLS  918u

// Ego vehicle dynamic
VehDyn_t* FusionInput_RawData;
// Lidar input
Lidar_input_lists* Lidartemp;
// Camera input
Camera_input_lists* Cameratemp;
// Result of fusion
ObjectList_t FusionOutput_ObjList;

// Fusion simulation timestamp
SimTimestamp fusion_cycle_ts;
// Ego vehicle simulation timestamp
SimTimestamp ego_veh_ts;
// Lidar simulation timestamp
SimTimestamp lidar_ts;
// Camera simulation timestamp
SimTimestamp camera_ts;
uint32 system_ts;

/*
FILE** lkf_pred_fptr;
FILE** lkf_correct_fptr;
FILE** ttta_internal_tracks_fptr;
FILE** ttta_meas_tracks_fptr;
FILE** ttta_matching_res_fptr;

static FILE* lkf_pred_log_file;
static FILE* lkf_correct_log_file;
static FILE* ttta_internal_tracks;
static FILE* ttta_meas_tracks;
static FILE* ttta_matching_res;
*/
typedef enum {
    EgoVehicleRecieved,
    LidarRecieved,
    CameraRecieved,
    PerformFusion,
    FusionFinished
} SensorTimingStatus;

/*
// Used for time synchronization
SensorTimingStatus timingCycle(){
    uint32 ego_veh_idx = ego_veh_ts.idx;
    uint32 lidar_idx = lidar_ts.idx;
    uint32 camera_idx = camera_ts.idx;
    uint32 fusion_ids = fusion_cycle_ts.idx;

    const SimTimestamp const ts_arr[] = {fusion_cycle_ts, ego_veh_ts, lidar_ts, camera_ts};
    boolean fin_status[4];
    checkFinishedStatus(ts_arr, 4, fin_status);

    if(fin_status[0]){ // No more fusion cycle
        return FusionFinished;
    } else {
        uint32 min_ts_idx = getMinTsWithMask(ts_arr, 4, fin_status);
        switch(min_ts_idx){
            case 0: // Perform fusion
                return PerformFusion;
            case 1:
                return EgoVehicleRecieved;
            case 2:
                return LidarRecieved;
            case 3:
                return CameraRecieved;
            default:
                LogWrite("Unknown status in timting cycle!");
                break;
        }
    }
}
*/
/*
void writeValFilesCols() {
    // write Kalman col update names to file:
    fprintf(*lkf_pred_fptr, "predicted,dt,nrows");
    fprintf(*lkf_pred_fptr, ",x,y,vx,vy,ax,ay");
    fprintf(*lkf_pred_fptr, ",var_x,var_y,var_vx,var_vy,var_ax,var_ay");
    fprintf(*lkf_pred_fptr, ",cov_x_y,cov_x_vx,cov_x_vy,cov_x_ax,cov_x_ay");
    fprintf(*lkf_pred_fptr, ",cov_y_vx,cov_y_vy,cov_y_ax,cov_y_ay");
    fprintf(*lkf_pred_fptr, ",cov_vx_vy,cov_vx_ax,cov_vx_ay");
    fprintf(*lkf_pred_fptr, ",cov_vy_ax,cov_vy_ay");
    fprintf(*lkf_pred_fptr, ",cov_ax_ay\n");

    // write Kalman correction col names to file:
    fprintf(*lkf_correct_fptr, "updated,nrows");
    fprintf(*lkf_correct_fptr, ",x,y,vx,vy,ax,ay");
    fprintf(*lkf_correct_fptr, ",var_x,var_y,var_vx,var_vy,var_ax,var_ay");
    fprintf(*lkf_correct_fptr, ",cov_x_y,cov_x_vx,cov_x_vy,cov_x_ax,cov_x_ay");
    fprintf(*lkf_correct_fptr, ",cov_y_vx,cov_y_vy,cov_y_ax,cov_y_ay");
    fprintf(*lkf_correct_fptr, ",cov_vx_vy,cov_vx_ax,cov_vx_ay");
    fprintf(*lkf_correct_fptr, ",cov_vy_ax,cov_vy_ay");
    fprintf(*lkf_correct_fptr, ",cov_ax_ay\n");

    // write TTTA internal tracks col name
    fprintf(*ttta_internal_tracks_fptr, "size,sensorId_0,sensorId_1,x,y,vx,vy,ax,ay");
    for (int i = 0; i < TUEOBJFUSN_SYMMETRIC_MATRIX_SIZE; i++)
        fprintf(*ttta_internal_tracks_fptr, ",P_%d", i);

    for (int i = 1; i < TUEOBJFUSN_TRACKABLELIST_U16VALIDTRACKABLES_MAX; i++) {
        fprintf(*ttta_internal_tracks_fptr, ",size,sensorId_0,sensorId_1,x,y,vx,vy,ax,ay");
        for(int j = 0; j < TUEOBJFUSN_SYMMETRIC_MATRIX_SIZE; j++)
            fprintf(*ttta_internal_tracks_fptr, ",P_%d", j);
    }
    fprintf(*ttta_internal_tracks_fptr, "\n");

    // write TTTA sensor tracks col name
    fprintf(*ttta_meas_tracks_fptr, "size,id,sensor_type,x,y,vx,vy,ax,ay");
    for (int i = 0; i < TUEOBJFUSN_SYMMETRIC_MATRIX_SIZE; i++)
        fprintf(*ttta_meas_tracks_fptr, ",P_%d", i);

    for (int i = 1; i < TUEOBJFUSN_OBJECTLIST_U16NUMOBJECTS_MAX; i++) {
        fprintf(*ttta_meas_tracks_fptr, ",size,id,sensor_type,x,y,vx,vy,ax,ay,id");
        for (int j = 0; j < TUEOBJFUSN_SYMMETRIC_MATRIX_SIZE; j++)
            fprintf(*ttta_meas_tracks_fptr, ",P_%d", j);
    }
    fprintf(*ttta_meas_tracks_fptr, "\n");

    // write TTTA matching results col name
    fprintf(*ttta_matching_res_fptr, "num_matches");
    for (int i = 0; i < TUE_PRV_MATCH_INDEX_ARRAY_SIZE; i++)
        fprintf(*ttta_matching_res_fptr, ",row%d,col%d", i, i);
    fprintf(*ttta_matching_res_fptr, "\n");
}
*/

int main(){
	ara::log::InitLogging("DPC", "FUSION_TEST",
							  ara::log::LogLevel::kVerbose,
							  (ara::log::LogMode::kConsole | ara::log::LogMode::kRemote));
	ara::exec::ExecutionClient execClient;
	execClient.ReportExecutionState(ara::exec::ExecutionState::kRunning);
	ara::log::Logger &mainLog
			{ ara::log::CreateLogger("main", "cm sample context",
									 ara::log::LogLevel::kVerbose) };
	mainLog.LogInfo() << "Let's produce some Fusion data...";
	GeneralWrapper gw(mainLog);
	setup_test();
	Fusion_Init();
	int Interval = 100;
	std::chrono::time_point<std::chrono::system_clock> start, end;
	start = std::chrono::system_clock::now();
	while(1)
		{
			end = std::chrono::system_clock::now();
			std::chrono::duration<double> elapsed_seconds = end - start;
			if (elapsed_seconds.count() >= Interval / 1000.0)
			{
				start = std::chrono::system_clock::now();
				auto lidadarObjectFromWrapper = gw._LidarPerception2Fusion_Required.s.GetData();
				auto vedDataFromWrapper = gw._VED2FusionEgoMotion_Required.s.GetData();
				auto frontCameraObjectsFromWrapper = gw._FrontCamDrvPerception2Fusion_Required.s.GetData();
				auto leftCameraObjectsFromWrapper = gw._LeftCamDrvPerception2Fusion_Required.s.GetData();
				auto righCameraObjectsFromWrapper = gw._RightCamDrvPerception2Fusion_Required.s.GetData();
				auto rearCameraObjectsFromWrapper = gw._RearCamDrvPerception2Fusion_Required.s.GetData();
				auto parkCameraObjectsFromWrapper = gw._FrontCamDrvPerception2Fusion_Required.s.GetData();
				auto c1 = CCameraObjectsWrapperToFusionCameraData::ConvertCamera2FusionCamera(frontCameraObjectsFromWrapper);
				auto c2 = CCameraObjectsWrapperToFusionCameraData::ConvertCamera2FusionCamera(leftCameraObjectsFromWrapper);
				auto c3 = CCameraObjectsWrapperToFusionCameraData::ConvertCamera2FusionCamera(righCameraObjectsFromWrapper);
				auto c4 = CCameraObjectsWrapperToFusionCameraData::ConvertCamera2FusionCamera(rearCameraObjectsFromWrapper);
				auto c5 = CCameraObjectsWrapperToFusionCameraData::ConvertCamera2FusionCamera(parkCameraObjectsFromWrapper);

				CCameraObjectsConcatenator::concatenate_camera_objs(Cameratemp,true,&std::get<0>(c1),std::get<1>(c1));
				CCameraObjectsConcatenator::concatenate_camera_objs(Cameratemp,false,&std::get<0>(c2),std::get<1>(c2));
				CCameraObjectsConcatenator::concatenate_camera_objs(Cameratemp,true,&std::get<0>(c3),std::get<1>(c3));
				CCameraObjectsConcatenator::concatenate_camera_objs(Cameratemp,false,&std::get<0>(c4),std::get<1>(c5));
				CCameraObjectsConcatenator::concatenate_camera_objs(Cameratemp,false,&std::get<0>(c4),std::get<1>(c5));

				*Lidartemp = CLidarObjectsWrapperToFusion::ConvertLidar2FusionToLIdar(lidadarObjectFromWrapper);

				Fusion_Process();
//				auto outPutData = CFusionObjectToWrapperObject::ConvertFusion2WrapperObject(FusionOutput_ObjList);
				//subscribe data
//				gw._Object_Provide.s.SetData(outPutData);
				gw._Object_Provide.Publish();
			}
			else
				usleep(1);
		}
    return 0;
}






